/**
 * POCDMT000040EntryRelationship2.java
 *
 * File generated from the cdaepsos2::POCDMT000040EntryRelationship2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos2;

import java.util.ArrayList;
import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class POCDMT000040EntryRelationship2.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.EntryRelationship", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"sequenceNumber",
	"seperatableInd",
	"act",
	"encounter",
	"observation",
	"observationMedia",
	"organizer",
	"procedure",
	"regionOfInterest",
	"substanceAdministration",
	"supply",
	"contextConductionInd",
	"inversionInd",
	"negationInd",
	"nullFlavor",
	"typeCode"
})
@XmlRootElement(name = "POCD_MT000040.EntryRelationship")
public class POCDMT000040EntryRelationship2 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "sequenceNumber", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.INT sequenceNumber;
	@XmlElement(name = "seperatableInd", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.BL seperatableInd;
	@XmlElement(name = "act", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Act2 act;
	@XmlElement(name = "encounter", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Encounter2 encounter;
	@XmlElement(name = "observation", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Observation2 observation;
	@XmlElement(name = "observationMedia", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040ObservationMedia2 observationMedia;
	@XmlElement(name = "organizer", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Organizer2 organizer;
	@XmlElement(name = "procedure", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Procedure2 procedure;
	@XmlElement(name = "regionOfInterest", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040RegionOfInterest2 regionOfInterest;
	@XmlElement(name = "substanceAdministration", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040SubstanceAdministration2 substanceAdministration;
	@XmlElement(name = "supply", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Supply2 supply;
	@XmlAttribute(name = "contextConductionInd")
	public Boolean contextConductionInd;
	@XmlAttribute(name = "inversionInd")
	public Boolean inversionInd;
	@XmlAttribute(name = "negationInd")
	public Boolean negationInd;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	@XmlAttribute(name = "typeCode", required = true)
	public net.ihe.gazelle.voc.XActRelationshipEntryRelationship typeCode;
	@XmlTransient
	private Object _parent;
	
	void afterUnmarshal( javax.xml.bind.Unmarshaller u, Object parent ){
		this._parent = parent;
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return sequenceNumber.
	 * @return sequenceNumber
	 */
	public net.ihe.gazelle.datatypes.INT getSequenceNumber() {
	    return sequenceNumber;
	}
	
	/**
	 * Set a value to attribute sequenceNumber.
	 * @param sequenceNumber.
	 */
	public void setSequenceNumber(net.ihe.gazelle.datatypes.INT sequenceNumber) {
	    this.sequenceNumber = sequenceNumber;
	}
	
	
	
	
	/**
	 * Return seperatableInd.
	 * @return seperatableInd
	 */
	public net.ihe.gazelle.datatypes.BL getSeperatableInd() {
	    return seperatableInd;
	}
	
	/**
	 * Set a value to attribute seperatableInd.
	 * @param seperatableInd.
	 */
	public void setSeperatableInd(net.ihe.gazelle.datatypes.BL seperatableInd) {
	    this.seperatableInd = seperatableInd;
	}
	
	
	
	
	/**
	 * Return act.
	 * @return act
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Act2 getAct() {
	    return act;
	}
	
	/**
	 * Set a value to attribute act.
	 * @param act.
	 */
	public void setAct(net.ihe.gazelle.cdaepsos2.POCDMT000040Act2 act) {
	    this.act = act;
	}
	
	
	
	
	/**
	 * Return encounter.
	 * @return encounter
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Encounter2 getEncounter() {
	    return encounter;
	}
	
	/**
	 * Set a value to attribute encounter.
	 * @param encounter.
	 */
	public void setEncounter(net.ihe.gazelle.cdaepsos2.POCDMT000040Encounter2 encounter) {
	    this.encounter = encounter;
	}
	
	
	
	
	/**
	 * Return observation.
	 * @return observation
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Observation2 getObservation() {
	    return observation;
	}
	
	/**
	 * Set a value to attribute observation.
	 * @param observation.
	 */
	public void setObservation(net.ihe.gazelle.cdaepsos2.POCDMT000040Observation2 observation) {
	    this.observation = observation;
	}
	
	
	
	
	/**
	 * Return observationMedia.
	 * @return observationMedia
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040ObservationMedia2 getObservationMedia() {
	    return observationMedia;
	}
	
	/**
	 * Set a value to attribute observationMedia.
	 * @param observationMedia.
	 */
	public void setObservationMedia(net.ihe.gazelle.cdaepsos2.POCDMT000040ObservationMedia2 observationMedia) {
	    this.observationMedia = observationMedia;
	}
	
	
	
	
	/**
	 * Return organizer.
	 * @return organizer
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Organizer2 getOrganizer() {
	    return organizer;
	}
	
	/**
	 * Set a value to attribute organizer.
	 * @param organizer.
	 */
	public void setOrganizer(net.ihe.gazelle.cdaepsos2.POCDMT000040Organizer2 organizer) {
	    this.organizer = organizer;
	}
	
	
	
	
	/**
	 * Return procedure.
	 * @return procedure
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Procedure2 getProcedure() {
	    return procedure;
	}
	
	/**
	 * Set a value to attribute procedure.
	 * @param procedure.
	 */
	public void setProcedure(net.ihe.gazelle.cdaepsos2.POCDMT000040Procedure2 procedure) {
	    this.procedure = procedure;
	}
	
	
	
	
	/**
	 * Return regionOfInterest.
	 * @return regionOfInterest
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040RegionOfInterest2 getRegionOfInterest() {
	    return regionOfInterest;
	}
	
	/**
	 * Set a value to attribute regionOfInterest.
	 * @param regionOfInterest.
	 */
	public void setRegionOfInterest(net.ihe.gazelle.cdaepsos2.POCDMT000040RegionOfInterest2 regionOfInterest) {
	    this.regionOfInterest = regionOfInterest;
	}
	
	
	
	
	/**
	 * Return substanceAdministration.
	 * @return substanceAdministration
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040SubstanceAdministration2 getSubstanceAdministration() {
	    return substanceAdministration;
	}
	
	/**
	 * Set a value to attribute substanceAdministration.
	 * @param substanceAdministration.
	 */
	public void setSubstanceAdministration(net.ihe.gazelle.cdaepsos2.POCDMT000040SubstanceAdministration2 substanceAdministration) {
	    this.substanceAdministration = substanceAdministration;
	}
	
	
	
	
	/**
	 * Return supply.
	 * @return supply
	 */
	public net.ihe.gazelle.cdaepsos2.POCDMT000040Supply2 getSupply() {
	    return supply;
	}
	
	/**
	 * Set a value to attribute supply.
	 * @param supply.
	 */
	public void setSupply(net.ihe.gazelle.cdaepsos2.POCDMT000040Supply2 supply) {
	    this.supply = supply;
	}
	
	
	
	
	/**
	 * Return contextConductionInd.
	 * @return contextConductionInd
	 */
	public Boolean getContextConductionInd() {
	    return contextConductionInd;
	}
	
	/**
	 * Set a value to attribute contextConductionInd.
	 * @param contextConductionInd.
	 */
	public void setContextConductionInd(Boolean contextConductionInd) {
	    this.contextConductionInd = contextConductionInd;
	}
	
	
	/**
	 * Return contextConductionInd.
	 * @return contextConductionInd
	 * Generated for the use on jsf pages
	 */
	 @Deprecated
	public Boolean isContextConductionInd() {
	    return contextConductionInd;
	}
	
	/**
	 * Return inversionInd.
	 * @return inversionInd
	 */
	public Boolean getInversionInd() {
	    return inversionInd;
	}
	
	/**
	 * Set a value to attribute inversionInd.
	 * @param inversionInd.
	 */
	public void setInversionInd(Boolean inversionInd) {
	    this.inversionInd = inversionInd;
	}
	
	
	/**
	 * Return inversionInd.
	 * @return inversionInd
	 * Generated for the use on jsf pages
	 */
	 @Deprecated
	public Boolean isInversionInd() {
	    return inversionInd;
	}
	
	/**
	 * Return negationInd.
	 * @return negationInd
	 */
	public Boolean getNegationInd() {
	    return negationInd;
	}
	
	/**
	 * Set a value to attribute negationInd.
	 * @param negationInd.
	 */
	public void setNegationInd(Boolean negationInd) {
	    this.negationInd = negationInd;
	}
	
	
	/**
	 * Return negationInd.
	 * @return negationInd
	 * Generated for the use on jsf pages
	 */
	 @Deprecated
	public Boolean isNegationInd() {
	    return negationInd;
	}
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	/**
	 * Return typeCode.
	 * @return typeCode
	 */
	public net.ihe.gazelle.voc.XActRelationshipEntryRelationship getTypeCode() {
	    return typeCode;
	}
	
	/**
	 * Set a value to attribute typeCode.
	 * @param typeCode.
	 */
	public void setTypeCode(net.ihe.gazelle.voc.XActRelationshipEntryRelationship typeCode) {
	    this.typeCode = typeCode;
	}
	
	
	
	
	/**
	 * Return _parent.
	 * @return _parent
	 */
	public Object get_parent() {
	    return _parent;
	}
	
	/**
	 * Set a value to attribute _parent.
	 * @param _parent.
	 */
	public void set_parent(String _parent) {
	    this._parent = _parent;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.EntryRelationship").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040EntryRelationship2 pOCDMT000040EntryRelationship2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040EntryRelationship2 != null){
   			cvm.validate(pOCDMT000040EntryRelationship2, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040EntryRelationship2.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040EntryRelationship2.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040EntryRelationship2.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.INT.validateByModule(pOCDMT000040EntryRelationship2.getSequenceNumber(), _location + "/sequenceNumber", cvm, diagnostic);
			net.ihe.gazelle.datatypes.BL.validateByModule(pOCDMT000040EntryRelationship2.getSeperatableInd(), _location + "/seperatableInd", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040Act2.validateByModule(pOCDMT000040EntryRelationship2.getAct(), _location + "/act", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040Encounter2.validateByModule(pOCDMT000040EntryRelationship2.getEncounter(), _location + "/encounter", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040Observation2.validateByModule(pOCDMT000040EntryRelationship2.getObservation(), _location + "/observation", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040ObservationMedia2.validateByModule(pOCDMT000040EntryRelationship2.getObservationMedia(), _location + "/observationMedia", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040Organizer2.validateByModule(pOCDMT000040EntryRelationship2.getOrganizer(), _location + "/organizer", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040Procedure2.validateByModule(pOCDMT000040EntryRelationship2.getProcedure(), _location + "/procedure", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040RegionOfInterest2.validateByModule(pOCDMT000040EntryRelationship2.getRegionOfInterest(), _location + "/regionOfInterest", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040SubstanceAdministration2.validateByModule(pOCDMT000040EntryRelationship2.getSubstanceAdministration(), _location + "/substanceAdministration", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos2.POCDMT000040Supply2.validateByModule(pOCDMT000040EntryRelationship2.getSupply(), _location + "/supply", cvm, diagnostic);
    	}
    }

}